package sun.swing;

import javax.swing.TransferHandler;
import java.awt.Point;
import sun.awt.AWTAccessor;
import java.awt.event.MouseListener;
import javax.swing.DefaultListCellRenderer;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.table.TableCellRenderer;
import java.util.Date;
import java.awt.Insets;
import java.text.DateFormat;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.DefaultCellEditor;
import javax.swing.DefaultRowSorter;
import java.util.concurrent.Callable;
import java.util.Comparator;
import javax.swing.table.TableRowSorter;
import javax.swing.RowSorter;
import java.util.List;
import javax.swing.table.AbstractTableModel;
import javax.swing.event.RowSorterEvent;
import javax.swing.event.RowSorterListener;
import javax.swing.event.TableModelListener;
import javax.swing.AbstractListModel;
import java.io.FileNotFoundException;
import sun.awt.shell.ShellFolder;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.ButtonGroup;
import java.beans.PropertyChangeEvent;
import javax.swing.DefaultListSelectionModel;
import java.util.Arrays;
import javax.swing.filechooser.FileSystemView;
import javax.swing.JOptionPane;
import java.text.MessageFormat;
import javax.swing.Icon;
import java.awt.ComponentOrientation;
import java.awt.Rectangle;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableCellEditor;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentAdapter;
import javax.swing.LookAndFeel;
import javax.swing.SwingUtilities;
import java.awt.Dimension;
import javax.swing.event.TableModelEvent;
import javax.swing.table.TableModel;
import sun.awt.shell.ShellFolderColumnInfo;
import javax.swing.table.TableColumn;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.JScrollPane;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.ListModel;
import javax.swing.text.Position;
import javax.swing.ActionMap;
import java.util.ArrayList;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import java.util.Locale;
import javax.swing.JComponent;
import java.awt.Container;
import java.awt.Component;
import javax.swing.Scrollable;
import java.awt.KeyboardFocusManager;
import java.awt.event.FocusEvent;
import java.awt.event.FocusAdapter;
import javax.swing.JFileChooser;
import javax.swing.plaf.basic.BasicDirectoryModel;
import javax.swing.InputMap;
import javax.swing.KeyStroke;
import java.awt.event.KeyEvent;
import javax.swing.UIManager;
import java.awt.event.KeyAdapter;
import java.awt.BorderLayout;
import javax.swing.JTextField;
import java.io.File;
import javax.swing.JTable;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import java.awt.Color;
import javax.swing.border.Border;
import java.awt.event.FocusListener;
import java.awt.event.KeyListener;
import java.awt.Cursor;
import javax.swing.JMenu;
import javax.swing.JPopupMenu;
import javax.swing.Action;
import java.beans.PropertyChangeListener;
import javax.swing.JPanel;

public class FilePane extends JPanel implements PropertyChangeListener
{
    public static final String ACTION_APPROVE_SELECTION = "approveSelection";
    public static final String ACTION_CANCEL = "cancelSelection";
    public static final String ACTION_EDIT_FILE_NAME = "editFileName";
    public static final String ACTION_REFRESH = "refresh";
    public static final String ACTION_CHANGE_TO_PARENT_DIRECTORY = "Go Up";
    public static final String ACTION_NEW_FOLDER = "New Folder";
    public static final String ACTION_VIEW_LIST = "viewTypeList";
    public static final String ACTION_VIEW_DETAILS = "viewTypeDetails";
    private Action[] actions;
    public static final int VIEWTYPE_LIST = 0;
    public static final int VIEWTYPE_DETAILS = 1;
    private static final int VIEWTYPE_COUNT = 2;
    private int viewType;
    private JPanel[] viewPanels;
    private JPanel currentViewPanel;
    private String[] viewTypeActionNames;
    private String filesListAccessibleName;
    private String filesDetailsAccessibleName;
    private JPopupMenu contextMenu;
    private JMenu viewMenu;
    private String viewMenuLabelText;
    private String refreshActionLabelText;
    private String newFolderActionLabelText;
    private String kiloByteString;
    private String megaByteString;
    private String gigaByteString;
    private String renameErrorTitleText;
    private String renameErrorText;
    private String renameErrorFileExistsText;
    private static final Cursor waitCursor;
    private final KeyListener detailsKeyListener;
    private FocusListener editorFocusListener;
    private static FocusListener repaintListener;
    private boolean smallIconsView;
    private Border listViewBorder;
    private Color listViewBackground;
    private boolean listViewWindowsStyle;
    private boolean readOnly;
    private boolean fullRowSelection;
    private ListSelectionModel listSelectionModel;
    private JList list;
    private JTable detailsTable;
    private static final int COLUMN_FILENAME = 0;
    private File newFolderFile;
    private FilePane.FileChooserUIAccessor fileChooserUIAccessor;
    private FilePane.DetailsTableModel detailsTableModel;
    private FilePane.DetailsTableRowSorter rowSorter;
    private FilePane.DetailsTableCellEditor tableCellEditor;
    int lastIndex;
    File editFile;
    JTextField editCell;
    protected Action newFolderAction;
    private FilePane.Handler handler;
    
    public FilePane(FilePane.FileChooserUIAccessor fileChooserUIAccessor) {
        super(new BorderLayout());
        this.viewType = -1;
        this.viewPanels = new JPanel[2];
        this.filesListAccessibleName = null;
        this.filesDetailsAccessibleName = null;
        this.detailsKeyListener = new KeyAdapter() {
            private final long timeFactor;
            private final StringBuilder typedString = new StringBuilder();
            private long lastTime = 1000L;
            
            {
                Long n = (Long)UIManager.get("Table.timeFactor");
                this.timeFactor = ((n != null) ? ((long)n) : 1000L);
            }
            
            @Override
            public void keyTyped(KeyEvent anEvent) {
                int size = FilePane.this.getModel().getSize();
                if (FilePane.this.detailsTable == null || size == 0 || anEvent.isAltDown() || anEvent.isControlDown() || anEvent.isMetaDown()) {
                    return;
                }
                InputMap inputMap = FilePane.this.detailsTable.getInputMap(1);
                KeyStroke keyStrokeForEvent = KeyStroke.getKeyStrokeForEvent(anEvent);
                if (inputMap != null && inputMap.get(keyStrokeForEvent) != null) {
                    return;
                }
                int leadSelectionIndex = FilePane.this.detailsTable.getSelectionModel().getLeadSelectionIndex();
                if (leadSelectionIndex < 0) {
                    leadSelectionIndex = 0;
                }
                if (leadSelectionIndex >= size) {
                    leadSelectionIndex = size - 1;
                }
                int keyChar = anEvent.getKeyChar();
                long when = anEvent.getWhen();
                if (when - this.lastTime < this.timeFactor) {
                    if (this.typedString.length() == 1 && this.typedString.charAt(0) == keyChar) {
                        ++leadSelectionIndex;
                    }
                    else {
                        this.typedString.append((char)keyChar);
                    }
                }
                else {
                    ++leadSelectionIndex;
                    this.typedString.setLength(0);
                    this.typedString.append((char)keyChar);
                }
                this.lastTime = when;
                if (leadSelectionIndex >= size) {
                    leadSelectionIndex = 0;
                }
                int row = this.getNextMatch(leadSelectionIndex, size - 1);
                if (row < 0 && leadSelectionIndex > 0) {
                    row = this.getNextMatch(0, leadSelectionIndex - 1);
                }
                if (row >= 0) {
                    FilePane.this.detailsTable.getSelectionModel().setSelectionInterval(row, row);
                    FilePane.this.detailsTable.scrollRectToVisible(FilePane.this.detailsTable.getCellRect(row, FilePane.this.detailsTable.convertColumnIndexToView(0), false));
                }
                return;
            }
            
            private int getNextMatch(int i, int n) {
                BasicDirectoryModel model = FilePane.this.getModel();
                JFileChooser fileChooser = FilePane.this.getFileChooser();
                FilePane.DetailsTableRowSorter access$100 = FilePane.access$100(FilePane.this);
                String lowerCase = this.typedString.toString().toLowerCase();
                while (i <= n) {
                    if (fileChooser.getName((File)model.getElementAt(access$100.convertRowIndexToModel(i))).toLowerCase().startsWith(lowerCase)) {
                        return i;
                    }
                    ++i;
                }
                return -1;
            }
        };
        this.editorFocusListener = new FocusAdapter() {
            @Override
            public void focusLost(FocusEvent focusEvent) {
                if (!focusEvent.isTemporary()) {
                    FilePane.access$200(FilePane.this);
                }
            }
        };
        this.smallIconsView = false;
        this.fullRowSelection = false;
        this.lastIndex = -1;
        this.editFile = null;
        this.editCell = null;
        this.fileChooserUIAccessor = fileChooserUIAccessor;
        this.installDefaults();
        this.createActionMap();
    }
    
    public void uninstallUI() {
        if (this.getModel() != null) {
            this.getModel().removePropertyChangeListener(this);
        }
    }
    
    protected JFileChooser getFileChooser() {
        return this.fileChooserUIAccessor.getFileChooser();
    }
    
    protected BasicDirectoryModel getModel() {
        return this.fileChooserUIAccessor.getModel();
    }
    
    public int getViewType() {
        return this.viewType;
    }
    
    public void setViewType(int n) {
        if (n == this.viewType) {
            return;
        }
        int viewType = this.viewType;
        this.viewType = n;
        JPanel panel = null;
        Scrollable scrollable = null;
        switch (n) {
            case 0: {
                if (this.viewPanels[n] == null) {
                    panel = this.fileChooserUIAccessor.createList();
                    if (panel == null) {
                        panel = this.createList();
                    }
                    this.list = (JList)this.findChildComponent(panel, JList.class);
                    if (this.listSelectionModel == null) {
                        this.listSelectionModel = this.list.getSelectionModel();
                        if (this.detailsTable != null) {
                            this.detailsTable.setSelectionModel(this.listSelectionModel);
                        }
                    }
                    else {
                        this.list.setSelectionModel(this.listSelectionModel);
                    }
                }
                this.list.setLayoutOrientation(1);
                scrollable = this.list;
                break;
            }
            case 1: {
                if (this.viewPanels[n] == null) {
                    panel = this.fileChooserUIAccessor.createDetailsView();
                    if (panel == null) {
                        panel = this.createDetailsView();
                    }
                    (this.detailsTable = (JTable)this.findChildComponent(panel, JTable.class)).setRowHeight(Math.max(this.detailsTable.getFont().getSize() + 4, 17));
                    if (this.listSelectionModel != null) {
                        this.detailsTable.setSelectionModel(this.listSelectionModel);
                    }
                }
                scrollable = this.detailsTable;
                break;
            }
        }
        if (panel != null) {
            recursivelySetInheritsPopupMenu(this.viewPanels[n] = panel, true);
        }
        boolean n2 = false;
        if (this.currentViewPanel != null) {
            Component permanentFocusOwner = KeyboardFocusManager.getCurrentKeyboardFocusManager().getPermanentFocusOwner();
            n2 = (permanentFocusOwner == this.detailsTable || permanentFocusOwner == this.list);
            this.remove(this.currentViewPanel);
        }
        this.add(this.currentViewPanel = this.viewPanels[n], "Center");
        if (n2 && scrollable != null) {
            scrollable.requestFocusInWindow();
        }
        this.revalidate();
        this.repaint();
        this.updateViewMenu();
        this.firePropertyChange("viewType", viewType, n);
        return;
    }
    
    public Action getViewTypeAction(int n) {
        return new FilePane.ViewTypeAction(n);
    }
    
    private static void recursivelySetInheritsPopupMenu(Container container, boolean inheritsPopupMenu) {
        if ((container instanceof JComponent)) {
            ((JComponent)container).setInheritsPopupMenu(inheritsPopupMenu);
        }
        for (int componentCount = container.getComponentCount(), i = 0; i < componentCount; ++i) {
            recursivelySetInheritsPopupMenu((Container)container.getComponent(i), inheritsPopupMenu);
        }
    }
    
    protected void installDefaults() {
        Locale locale = this.getFileChooser().getLocale();
        this.listViewBorder = UIManager.getBorder("FileChooser.listViewBorder");
        this.listViewBackground = UIManager.getColor("FileChooser.listViewBackground");
        this.listViewWindowsStyle = UIManager.getBoolean("FileChooser.listViewWindowsStyle");
        this.readOnly = UIManager.getBoolean("FileChooser.readOnly");
        this.viewMenuLabelText = UIManager.getString("FileChooser.viewMenuLabelText", locale);
        this.refreshActionLabelText = UIManager.getString("FileChooser.refreshActionLabelText", locale);
        this.newFolderActionLabelText = UIManager.getString("FileChooser.newFolderActionLabelText", locale);
        (this.viewTypeActionNames = new String[2])[0] = UIManager.getString("FileChooser.listViewActionLabelText", locale);
        this.viewTypeActionNames[1] = UIManager.getString("FileChooser.detailsViewActionLabelText", locale);
        this.kiloByteString = UIManager.getString("FileChooser.fileSizeKiloBytes", locale);
        this.megaByteString = UIManager.getString("FileChooser.fileSizeMegaBytes", locale);
        this.gigaByteString = UIManager.getString("FileChooser.fileSizeGigaBytes", locale);
        this.fullRowSelection = UIManager.getBoolean("FileView.fullRowSelection");
        this.filesListAccessibleName = UIManager.getString("FileChooser.filesListAccessibleName", locale);
        this.filesDetailsAccessibleName = UIManager.getString("FileChooser.filesDetailsAccessibleName", locale);
        this.renameErrorTitleText = UIManager.getString("FileChooser.renameErrorTitleText", locale);
        this.renameErrorText = UIManager.getString("FileChooser.renameErrorText", locale);
        this.renameErrorFileExistsText = UIManager.getString("FileChooser.renameErrorFileExistsText", locale);
    }
    
    public Action[] getActions() {
        if (this.actions == null) {
            ArrayList list = new ArrayList(8);
            class FilePaneAction extends AbstractAction
            {
                FilePaneAction(FilePane filePane, String s) {
                    this(filePane, s, s);
                }
                
                FilePaneAction(String name, String newValue) {
                    super(name);
                    this.putValue("ActionCommandKey", newValue);
                }
                
                @Override
                public void actionPerformed(ActionEvent actionEvent) {
                    String s = (String)this.getValue("ActionCommandKey");
                    if (s == "cancelSelection") {
                        if (FilePane.this.editFile != null) {
                            FilePane.access$400(FilePane.this);
                        }
                        else {
                            FilePane.this.getFileChooser().cancelSelection();
                        }
                    }
                    else if (s == "editFileName") {
                        JFileChooser fileChooser = FilePane.this.getFileChooser();
                        int minSelectionIndex = FilePane.this.listSelectionModel.getMinSelectionIndex();
                        if (minSelectionIndex >= 0 && FilePane.this.editFile == null && (!fileChooser.isMultiSelectionEnabled() || fileChooser.getSelectedFiles().length <= 1)) {
                            FilePane.access$600(FilePane.this, minSelectionIndex);
                        }
                    }
                    else if (s == "refresh") {
                        FilePane.this.getFileChooser().rescanCurrentDirectory();
                    }
                }
                
                @Override
                public boolean isEnabled() {
                    String s = (String)this.getValue("ActionCommandKey");
                    if (s == "cancelSelection") {
                        return FilePane.this.getFileChooser().isEnabled();
                    }
                    return s != "editFileName" || (!FilePane.this.readOnly && FilePane.this.getFileChooser().isEnabled());
                }
            }
            list.add(new FilePaneAction("cancelSelection"));
            list.add(new FilePaneAction("editFileName"));
            list.add(new FilePaneAction(this.refreshActionLabelText, "refresh"));
            Action approveSelectionAction = this.fileChooserUIAccessor.getApproveSelectionAction();
            if (approveSelectionAction != null) {
                list.add(approveSelectionAction);
            }
            Action changeToParentDirectoryAction = this.fileChooserUIAccessor.getChangeToParentDirectoryAction();
            if (changeToParentDirectoryAction != null) {
                list.add(changeToParentDirectoryAction);
            }
            Action newFolderAction = this.getNewFolderAction();
            if (newFolderAction != null) {
                list.add(newFolderAction);
            }
            Action viewTypeAction = this.getViewTypeAction(0);
            if (viewTypeAction != null) {
                list.add(viewTypeAction);
            }
            Action viewTypeAction2 = this.getViewTypeAction(1);
            if (viewTypeAction2 != null) {
                list.add(viewTypeAction2);
            }
            this.actions = (Action[])list.toArray(new Action[list.size()]);
        }
        return this.actions;
    }
    
    protected void createActionMap() {
        addActionsToMap(super.getActionMap(), this.getActions());
    }
    
    public static void addActionsToMap(ActionMap actionMap, Action[] array) {
        if (actionMap != null && array != null) {
            for (Action action : array) {
                String key = (String)action.getValue("ActionCommandKey");
                if (key == null) {
                    key = (String)action.getValue("Name");
                }
                actionMap.put(key, action);
            }
        }
    }
    
    private void updateListRowCount(JList list) {
        if (this.smallIconsView) {
            list.setVisibleRowCount(this.getModel().getSize() / 3);
        }
        else {
            list.setVisibleRowCount(-1);
        }
    }
    
    public JPanel createList() {
        JPanel panel = new JPanel(new BorderLayout());
        final JFileChooser fileChooser = this.getFileChooser();
        final JList<Object> view = new JList<Object>() {
            @Override
            public int getNextMatch(String other, int n, Position.Bias bias) {
                ListModel<Object> model = this.getModel();
                int size = model.getSize();
                if (other == null || n < 0 || n >= size) {
                    throw new IllegalArgumentException();
                }
                int n2 = bias == Position.Bias.Backward;
                while (n2 ? (n >= 0) : (n < size)) {
                    if (fileChooser.getName((File)model.getElementAt(n)).regionMatches(true, 0, other, 0, other.length())) {
                        return n;
                    }
                    n += (n2 ? -1 : 1);
                }
                return -1;
            }
        };
        view.setCellRenderer(new FilePane.FileRenderer());
        view.setLayoutOrientation(1);
        view.putClientProperty("List.isFileList", Boolean.TRUE);
        if (this.listViewWindowsStyle) {
            view.addFocusListener(FilePane.repaintListener);
        }
        this.updateListRowCount(view);
        this.getModel().addListDataListener(new ListDataListener() {
            @Override
            public void intervalAdded(ListDataEvent listDataEvent) {
                FilePane.access$800(FilePane.this, view);
            }
            
            @Override
            public void intervalRemoved(ListDataEvent listDataEvent) {
                FilePane.access$800(FilePane.this, view);
            }
            
            @Override
            public void contentsChanged(ListDataEvent listDataEvent) {
                if (FilePane.this.isShowing()) {
                    FilePane.this.clearSelection();
                }
                FilePane.access$800(FilePane.this, view);
            }
        });
        this.getModel().addPropertyChangeListener(this);
        if (fileChooser.isMultiSelectionEnabled()) {
            view.setSelectionMode(2);
        }
        else {
            view.setSelectionMode(0);
        }
        view.setModel(new FilePane.SortableListModel());
        view.addListSelectionListener(this.createListSelectionListener());
        view.addMouseListener(this.getMouseHandler());
        JScrollPane comp = new JScrollPane(view);
        if (this.listViewBackground != null) {
            view.setBackground(this.listViewBackground);
        }
        if (this.listViewBorder != null) {
            comp.setBorder(this.listViewBorder);
        }
        view.putClientProperty("AccessibleName", this.filesListAccessibleName);
        panel.add(comp, "Center");
        return panel;
    }
    
    private FilePane.DetailsTableModel getDetailsTableModel() {
        if (this.detailsTableModel == null) {
            this.detailsTableModel = new FilePane.DetailsTableModel(this.getFileChooser());
        }
        return this.detailsTableModel;
    }
    
    private void updateDetailsColumnModel(JTable table) {
        if (table != null) {
            ShellFolderColumnInfo[] columns = this.detailsTableModel.getColumns();
            DefaultTableColumnModel columnModel = new DefaultTableColumnModel();
            for (int i = 0; i < columns.length; ++i) {
                ShellFolderColumnInfo shellFolderColumnInfo = columns[i];
                TableColumn o = new TableColumn(i);
                String title = shellFolderColumnInfo.getTitle();
                if (title != null && title.startsWith("FileChooser.") && title.endsWith("HeaderText")) {
                    String string = UIManager.getString(title, table.getLocale());
                    if (string != null) {
                        title = string;
                    }
                }
                o.setHeaderValue(title);
                Integer width = shellFolderColumnInfo.getWidth();
                if (width != null) {
                    o.setPreferredWidth((int)width);
                }
                columnModel.addColumn(o);
            }
            if (!this.readOnly && columnModel.getColumnCount() > 0) {
                columnModel.getColumn(0).setCellEditor(this.getDetailsTableCellEditor());
            }
            table.setColumnModel(columnModel);
        }
    }
    
    private FilePane.DetailsTableRowSorter getRowSorter() {
        if (this.rowSorter == null) {
            this.rowSorter = new FilePane.DetailsTableRowSorter();
        }
        return this.rowSorter;
    }
    
    private FilePane.DetailsTableCellEditor getDetailsTableCellEditor() {
        if (this.tableCellEditor == null) {
            this.tableCellEditor = new FilePane.DetailsTableCellEditor(new JTextField());
        }
        return this.tableCellEditor;
    }
    
    public JPanel createDetailsView() {
        final JFileChooser fileChooser = this.getFileChooser();
        JPanel panel = new JPanel(new BorderLayout());
        JTable table = new JTable(this.getDetailsTableModel()) {
            @Override
            protected boolean processKeyBinding(KeyStroke ks, KeyEvent keyEvent, int condition, boolean pressed) {
                if (keyEvent.getKeyCode() == 27 && this.getCellEditor() == null) {
                    fileChooser.dispatchEvent(keyEvent);
                    return true;
                }
                return super.processKeyBinding(ks, keyEvent, condition, pressed);
            }
            
            @Override
            public void tableChanged(TableModelEvent e) {
                super.tableChanged(e);
                if (e.getFirstRow() == -1) {
                    FilePane.access$2500(FilePane.this, this);
                }
            }
        };
        table.setRowSorter(this.getRowSorter());
        table.setAutoCreateColumnsFromModel(false);
        table.setComponentOrientation(fileChooser.getComponentOrientation());
        table.setAutoResizeMode(0);
        table.setShowGrid(false);
        table.putClientProperty("JTable.autoStartsEdit", Boolean.FALSE);
        table.addKeyListener(this.detailsKeyListener);
        table.setFont(this.list.getFont());
        table.setIntercellSpacing(new Dimension(0, 0));
        table.getTableHeader().setDefaultRenderer(new FilePane.AlignableTableHeaderRenderer(table.getTableHeader().getDefaultRenderer()));
        table.setDefaultRenderer(Object.class, new FilePane.DetailsTableCellRenderer(fileChooser));
        table.getColumnModel().getSelectionModel().setSelectionMode(0);
        table.addMouseListener(this.getMouseHandler());
        table.putClientProperty("Table.isFileList", Boolean.TRUE);
        if (this.listViewWindowsStyle) {
            table.addFocusListener(FilePane.repaintListener);
        }
        ActionMap uiActionMap = SwingUtilities.getUIActionMap(table);
        uiActionMap.remove("selectNextRowCell");
        uiActionMap.remove("selectPreviousRowCell");
        uiActionMap.remove("selectNextColumnCell");
        uiActionMap.remove("selectPreviousColumnCell");
        table.setFocusTraversalKeys(0, null);
        table.setFocusTraversalKeys(1, null);
        JScrollPane comp = new JScrollPane(table);
        comp.setComponentOrientation(fileChooser.getComponentOrientation());
        LookAndFeel.installColors(comp.getViewport(), "Table.background", "Table.foreground");
        comp.addComponentListener(new ComponentAdapter() {
            @Override
            public void componentResized(ComponentEvent componentEvent) {
                JScrollPane scrollPane = (JScrollPane)componentEvent.getComponent();
                FilePane.access$2600(FilePane.this, scrollPane.getViewport().getSize().width);
                scrollPane.removeComponentListener(this);
            }
        });
        comp.addMouseListener(new MouseAdapter() {
            @Override
            public void mousePressed(MouseEvent mouseEvent) {
                JTable table = (JTable)((JScrollPane)mouseEvent.getComponent()).getViewport().getView();
                if (!mouseEvent.isShiftDown() || table.getSelectionModel().getSelectionMode() == 0) {
                    FilePane.this.clearSelection();
                    TableCellEditor cellEditor = table.getCellEditor();
                    if (cellEditor != null) {
                        cellEditor.stopCellEditing();
                    }
                }
            }
        });
        table.setForeground(this.list.getForeground());
        table.setBackground(this.list.getBackground());
        if (this.listViewBorder != null) {
            comp.setBorder(this.listViewBorder);
        }
        panel.add(comp, "Center");
        this.detailsTableModel.fireTableStructureChanged();
        table.putClientProperty("AccessibleName", this.filesDetailsAccessibleName);
        return panel;
    }
    
    private void fixNameColumnWidth(int n) {
        TableColumn column = this.detailsTable.getColumnModel().getColumn(0);
        int width = this.detailsTable.getPreferredSize().width;
        if (width < n) {
            column.setPreferredWidth(column.getPreferredWidth() + n - width);
        }
    }
    
    public ListSelectionListener createListSelectionListener() {
        return this.fileChooserUIAccessor.createListSelectionListener();
    }
    
    private int getEditIndex() {
        return this.lastIndex;
    }
    
    private void setEditIndex(int lastIndex) {
        this.lastIndex = lastIndex;
    }
    
    private void resetEditIndex() {
        this.lastIndex = -1;
    }
    
    private void cancelEdit() {
        if (this.editFile != null) {
            this.editFile = null;
            this.list.remove(this.editCell);
            this.repaint();
        }
        else if (this.detailsTable != null && this.detailsTable.isEditing()) {
            this.detailsTable.getCellEditor().cancelCellEditing();
        }
    }
    
    private void editFileName(int row) {
        JFileChooser fileChooser = this.getFileChooser();
        File currentDirectory = fileChooser.getCurrentDirectory();
        if (this.readOnly || !this.canWrite(currentDirectory)) {
            return;
        }
        this.ensureIndexIsVisible(row);
        switch (this.viewType) {
            case 0: {
                this.editFile = (File)this.getModel().getElementAt(this.getRowSorter().convertRowIndexToModel(row));
                Rectangle cellBounds = this.list.getCellBounds(row, row);
                if (this.editCell == null) {
                    (this.editCell = new JTextField()).setName("Tree.cellEditor");
                    this.editCell.addActionListener(new FilePane.EditActionListener());
                    this.editCell.addFocusListener(this.editorFocusListener);
                    this.editCell.setNextFocusableComponent(this.list);
                }
                this.list.add(this.editCell);
                this.editCell.setText(fileChooser.getName(this.editFile));
                ComponentOrientation componentOrientation = this.list.getComponentOrientation();
                this.editCell.setComponentOrientation(componentOrientation);
                Icon icon = fileChooser.getIcon(this.editFile);
                int n = (icon == null) ? 20 : (icon.getIconWidth() + 4);
                if (componentOrientation.isLeftToRight()) {
                    this.editCell.setBounds(n + cellBounds.x, cellBounds.y, cellBounds.width - n, cellBounds.height);
                }
                else {
                    this.editCell.setBounds(cellBounds.x, cellBounds.y, cellBounds.width - n, cellBounds.height);
                }
                this.editCell.requestFocus();
                this.editCell.selectAll();
                break;
            }
            case 1: {
                this.detailsTable.editCellAt(row, 0);
                break;
            }
        }
        return;
    }
    
    private void applyEdit() {
        if (this.editFile != null && this.editFile.exists()) {
            JFileChooser fileChooser = this.getFileChooser();
            String name = fileChooser.getName(this.editFile);
            String name2 = this.editFile.getName();
            String s = this.editCell.getText().trim();
            if (!s.equals(name)) {
                int length = name2.length();
                int length2 = name.length();
                if (length > length2 && name2.charAt(length2) == '.') {
                    s += name2.substring(length2);
                }
                FileSystemView fileSystemView = fileChooser.getFileSystemView();
                File fileObject = fileSystemView.createFileObject(this.editFile.getParentFile(), s);
                if (fileObject.exists()) {
                    JOptionPane.showMessageDialog(fileChooser, MessageFormat.format(this.renameErrorFileExistsText, new Object[] { name2 }), this.renameErrorTitleText, 0);
                }
                else if (this.getModel().renameFile(this.editFile, fileObject)) {
                    if (fileSystemView.isParent(fileChooser.getCurrentDirectory(), fileObject)) {
                        if (fileChooser.isMultiSelectionEnabled()) {
                            fileChooser.setSelectedFiles(new File[] { fileObject });
                        }
                        else {
                            fileChooser.setSelectedFile(fileObject);
                        }
                    }
                }
                else {
                    JOptionPane.showMessageDialog(fileChooser, MessageFormat.format(this.renameErrorText, new Object[] { name2 }), this.renameErrorTitleText, 0);
                }
            }
        }
        if (this.detailsTable != null && this.detailsTable.isEditing()) {
            this.detailsTable.getCellEditor().stopCellEditing();
        }
        this.cancelEdit();
    }
    
    public Action getNewFolderAction() {
        if (!this.readOnly && this.newFolderAction == null) {
            this.newFolderAction = new AbstractAction(this.newFolderActionLabelText) {
                private Action basicNewFolderAction;
                
                {
                    this.putValue("ActionCommandKey", "New Folder");
                    File currentDirectory = FilePane.this.getFileChooser().getCurrentDirectory();
                    if (currentDirectory != null) {
                        this.setEnabled(FilePane.this.canWrite(currentDirectory));
                    }
                }
                
                @Override
                public void actionPerformed(ActionEvent actionEvent) {
                    if (this.basicNewFolderAction == null) {
                        this.basicNewFolderAction = FilePane.this.fileChooserUIAccessor.getNewFolderAction();
                    }
                    JFileChooser fileChooser = FilePane.this.getFileChooser();
                    File selectedFile = fileChooser.getSelectedFile();
                    this.basicNewFolderAction.actionPerformed(actionEvent);
                    File selectedFile2 = fileChooser.getSelectedFile();
                    if (selectedFile2 != null && !selectedFile2.equals(selectedFile) && selectedFile2.isDirectory()) {
                        FilePane.this.newFolderFile = selectedFile2;
                    }
                }
            };
        }
        return this.newFolderAction;
    }
    
    void setFileSelected() {
        if (this.getFileChooser().isMultiSelectionEnabled() && !this.isDirectorySelected()) {
            File[] selectedFiles = this.getFileChooser().getSelectedFiles();
            Object[] selectedValues = this.list.getSelectedValues();
            this.listSelectionModel.setValueIsAdjusting(true);
            try {
                int leadSelectionIndex = this.listSelectionModel.getLeadSelectionIndex();
                int anchorSelectionIndex = this.listSelectionModel.getAnchorSelectionIndex();
                Arrays.sort(selectedFiles);
                Arrays.sort(selectedValues);
                int i = 0;
                int j = 0;
                while (i < selectedFiles.length && j < selectedValues.length) {
                    int compareTo = selectedFiles[i].compareTo((File)selectedValues[j]);
                    if (compareTo < 0) {
                        this.doSelectFile(selectedFiles[i++]);
                    }
                    else if (compareTo > 0) {
                        this.doDeselectFile(selectedValues[j++]);
                    }
                    else {
                        ++i;
                        ++j;
                    }
                }
                while (i < selectedFiles.length) {
                    this.doSelectFile(selectedFiles[i++]);
                }
                while (j < selectedValues.length) {
                    this.doDeselectFile(selectedValues[j++]);
                }
                if ((this.listSelectionModel instanceof DefaultListSelectionModel)) {
                    ((DefaultListSelectionModel)this.listSelectionModel).moveLeadSelectionIndex(leadSelectionIndex);
                    this.listSelectionModel.setAnchorSelectionIndex(anchorSelectionIndex);
                }
            }
            finally {
                this.listSelectionModel.setValueIsAdjusting(false);
            }
        }
        else {
            JFileChooser fileChooser = this.getFileChooser();
            File o;
            if (this.isDirectorySelected()) {
                o = this.getDirectory();
            }
            else {
                o = fileChooser.getSelectedFile();
            }
            int index;
            if (o != null && (index = this.getModel().indexOf(o)) >= 0) {
                int convertRowIndexToView = this.getRowSorter().convertRowIndexToView(index);
                this.listSelectionModel.setSelectionInterval(convertRowIndexToView, convertRowIndexToView);
                this.ensureIndexIsVisible(convertRowIndexToView);
            }
            else {
                this.clearSelection();
            }
        }
    }
    
    private void doSelectFile(File o) {
        int index = this.getModel().indexOf(o);
        if (index >= 0) {
            int convertRowIndexToView = this.getRowSorter().convertRowIndexToView(index);
            this.listSelectionModel.addSelectionInterval(convertRowIndexToView, convertRowIndexToView);
        }
    }
    
    private void doDeselectFile(Object o) {
        int convertRowIndexToView = this.getRowSorter().convertRowIndexToView(this.getModel().indexOf(o));
        this.listSelectionModel.removeSelectionInterval(convertRowIndexToView, convertRowIndexToView);
    }
    
    private void doSelectedFileChanged(PropertyChangeEvent propertyChangeEvent) {
        this.applyEdit();
        File file = (File)propertyChangeEvent.getNewValue();
        JFileChooser fileChooser = this.getFileChooser();
        if (file != null && ((fileChooser.isFileSelectionEnabled() && !file.isDirectory()) || (file.isDirectory() && fileChooser.isDirectorySelectionEnabled()))) {
            this.setFileSelected();
        }
    }
    
    private void doSelectedFilesChanged(PropertyChangeEvent propertyChangeEvent) {
        this.applyEdit();
        File[] array = (File[])(File[])propertyChangeEvent.getNewValue();
        JFileChooser fileChooser = this.getFileChooser();
        if (array != null && array.length > 0 && (array.length > 1 || fileChooser.isDirectorySelectionEnabled() || !array[0].isDirectory())) {
            this.setFileSelected();
        }
    }
    
    private void doDirectoryChanged(PropertyChangeEvent propertyChangeEvent) {
        this.getDetailsTableModel().updateColumnInfo();
        JFileChooser fileChooser = this.getFileChooser();
        FileSystemView fileSystemView = fileChooser.getFileSystemView();
        this.applyEdit();
        this.resetEditIndex();
        this.ensureIndexIsVisible(0);
        File currentDirectory = fileChooser.getCurrentDirectory();
        if (currentDirectory != null) {
            if (!this.readOnly) {
                this.getNewFolderAction().setEnabled(this.canWrite(currentDirectory));
            }
            this.fileChooserUIAccessor.getChangeToParentDirectoryAction().setEnabled(!fileSystemView.isRoot(currentDirectory));
        }
        if (this.list != null) {
            this.list.clearSelection();
        }
    }
    
    private void doFilterChanged(PropertyChangeEvent propertyChangeEvent) {
        this.applyEdit();
        this.resetEditIndex();
        this.clearSelection();
    }
    
    private void doFileSelectionModeChanged(PropertyChangeEvent propertyChangeEvent) {
        this.applyEdit();
        this.resetEditIndex();
        this.clearSelection();
    }
    
    private void doMultiSelectionChanged(PropertyChangeEvent propertyChangeEvent) {
        if (this.getFileChooser().isMultiSelectionEnabled()) {
            this.listSelectionModel.setSelectionMode(2);
        }
        else {
            this.listSelectionModel.setSelectionMode(0);
            this.clearSelection();
            this.getFileChooser().setSelectedFiles((File[])null);
        }
    }
    
    @Override
    public void propertyChange(PropertyChangeEvent propertyChangeEvent) {
        if (this.viewType == -1) {
            this.setViewType(0);
        }
        String propertyName = propertyChangeEvent.getPropertyName();
        if (propertyName.equals("SelectedFileChangedProperty")) {
            this.doSelectedFileChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("SelectedFilesChangedProperty")) {
            this.doSelectedFilesChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("directoryChanged")) {
            this.doDirectoryChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("fileFilterChanged")) {
            this.doFilterChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("fileSelectionChanged")) {
            this.doFileSelectionModeChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("MultiSelectionEnabledChangedProperty")) {
            this.doMultiSelectionChanged(propertyChangeEvent);
        }
        else if (propertyName.equals("CancelSelection")) {
            this.applyEdit();
        }
        else if (propertyName.equals("busy")) {
            this.setCursor(((boolean)propertyChangeEvent.getNewValue()) ? FilePane.waitCursor : null);
        }
        else if (propertyName.equals("componentOrientation")) {
            ComponentOrientation componentOrientation = (ComponentOrientation)propertyChangeEvent.getNewValue();
            JFileChooser fileChooser = (JFileChooser)propertyChangeEvent.getSource();
            if (componentOrientation != propertyChangeEvent.getOldValue()) {
                fileChooser.applyComponentOrientation(componentOrientation);
            }
            if (this.detailsTable != null) {
                this.detailsTable.setComponentOrientation(componentOrientation);
                this.detailsTable.getParent().getParent().setComponentOrientation(componentOrientation);
            }
        }
    }
    
    private void ensureIndexIsVisible(int n) {
        if (n >= 0) {
            if (this.list != null) {
                this.list.ensureIndexIsVisible(n);
            }
            if (this.detailsTable != null) {
                this.detailsTable.scrollRectToVisible(this.detailsTable.getCellRect(n, 0, true));
            }
        }
    }
    
    public void ensureFileIsVisible(JFileChooser fileChooser, File o) {
        int index = this.getModel().indexOf(o);
        if (index >= 0) {
            this.ensureIndexIsVisible(this.getRowSorter().convertRowIndexToView(index));
        }
    }
    
    public void rescanCurrentDirectory() {
        this.getModel().validateFileCache();
    }
    
    public void clearSelection() {
        if (this.listSelectionModel != null) {
            this.listSelectionModel.clearSelection();
            if ((this.listSelectionModel instanceof DefaultListSelectionModel)) {
                ((DefaultListSelectionModel)this.listSelectionModel).moveLeadSelectionIndex(0);
                this.listSelectionModel.setAnchorSelectionIndex(0);
            }
        }
    }
    
    public JMenu getViewMenu() {
        if (this.viewMenu == null) {
            this.viewMenu = new JMenu(this.viewMenuLabelText);
            ButtonGroup buttonGroup = new ButtonGroup();
            for (int i = 0; i < 2; ++i) {
                JRadioButtonMenuItem o = new JRadioButtonMenuItem(new FilePane.ViewTypeAction(i));
                buttonGroup.add(o);
                this.viewMenu.add(o);
            }
            this.updateViewMenu();
        }
        return this.viewMenu;
    }
    
    private void updateViewMenu() {
        if (this.viewMenu != null) {
            Component[] menuComponents;
            for (Component component : menuComponents = this.viewMenu.getMenuComponents()) {
                if ((component instanceof JRadioButtonMenuItem)) {
                    JRadioButtonMenuItem radioButtonMenuItem = (JRadioButtonMenuItem)component;
                    if (((FilePane.ViewTypeAction)radioButtonMenuItem.getAction()).viewType == this.viewType) {
                        radioButtonMenuItem.setSelected(true);
                    }
                }
            }
        }
    }
    
    @Override
    public JPopupMenu getComponentPopupMenu() {
        JPopupMenu componentPopupMenu = this.getFileChooser().getComponentPopupMenu();
        if (componentPopupMenu != null) {
            return componentPopupMenu;
        }
        JMenu viewMenu = this.getViewMenu();
        if (this.contextMenu == null) {
            this.contextMenu = new JPopupMenu();
            if (viewMenu != null) {
                this.contextMenu.add(viewMenu);
                if (this.listViewWindowsStyle) {
                    this.contextMenu.addSeparator();
                }
            }
            ActionMap actionMap = this.getActionMap();
            Action value = actionMap.get("refresh");
            Action value2 = actionMap.get("New Folder");
            if (value != null) {
                this.contextMenu.add(value);
                if (this.listViewWindowsStyle && value2 != null) {
                    this.contextMenu.addSeparator();
                }
            }
            if (value2 != null) {
                this.contextMenu.add(value2);
            }
        }
        if (viewMenu != null) {
            viewMenu.getPopupMenu().setInvoker(viewMenu);
        }
        return this.contextMenu;
    }
    
    protected FilePane.Handler getMouseHandler() {
        if (this.handler == null) {
            this.handler = new FilePane.Handler();
        }
        return this.handler;
    }
    
    protected boolean isDirectorySelected() {
        return this.fileChooserUIAccessor.isDirectorySelected();
    }
    
    protected File getDirectory() {
        return this.fileChooserUIAccessor.getDirectory();
    }
    
    private Component findChildComponent(Container container, Class clazz) {
        int componentCount = container.getComponentCount();
        int i = 0;
        while (i < componentCount) {
            Component component = container.getComponent(i);
            if (clazz.isInstance(component)) {
                return component;
            }
            if ((component instanceof Container)) {
                Component childComponent = this.findChildComponent((Container)component, clazz);
                if (childComponent != null) {
                    return childComponent;
                }
            }
            ++i;
        }
        return null;
    }
    
    public boolean canWrite(File file) {
        if (!file.exists()) {
            return false;
        }
        try {
            if ((file instanceof ShellFolder)) {
                return file.canWrite();
            }
            if (usesShellFolder(this.getFileChooser())) {
                try {
                    return ShellFolder.getShellFolder(file).canWrite();
                }
                catch (FileNotFoundException ex) {
                    return false;
                }
            }
            else {
                return file.canWrite();
            }
        }
        catch (SecurityException ex2) {
            return false;
        }
    }
    
    public static boolean usesShellFolder(JFileChooser fileChooser) {
        Boolean b = (Boolean)fileChooser.getClientProperty("FileChooser.useShellFolder");
        return (b == null) ? fileChooser.getFileSystemView().equals(FileSystemView.getFileSystemView()) : ((boolean)b);
    }
    
    static FilePane.DetailsTableRowSorter access$100(FilePane filePane) {
        return filePane.getRowSorter();
    }
    
    static void access$200(FilePane filePane) {
        filePane.applyEdit();
    }
    
    static void access$400(FilePane filePane) {
        filePane.cancelEdit();
    }
    
    static void access$600(FilePane filePane, int n) {
        filePane.editFileName(n);
    }
    
    static void access$800(FilePane filePane, JList list) {
        filePane.updateListRowCount(list);
    }
    
    static FilePane.DetailsTableModel access$900(FilePane filePane) {
        return filePane.getDetailsTableModel();
    }
    
    static void access$2500(FilePane filePane, JTable table) {
        filePane.updateDetailsColumnModel(table);
    }
    
    static void access$2600(FilePane filePane, int n) {
        filePane.fixNameColumnWidth(n);
    }
    
    static int access$3100(FilePane filePane) {
        return filePane.getEditIndex();
    }
    
    static void access$3200(FilePane filePane, int editIndex) {
        filePane.setEditIndex(editIndex);
    }
    
    static void access$3300(FilePane filePane) {
        filePane.resetEditIndex();
    }
    
    static {
        waitCursor = Cursor.getPredefinedCursor(3);
        FilePane.repaintListener = new FocusListener() {
            @Override
            public void focusGained(FocusEvent focusEvent) {
                this.repaintSelection(focusEvent.getSource());
            }
            
            @Override
            public void focusLost(FocusEvent focusEvent) {
                this.repaintSelection(focusEvent.getSource());
            }
            
            private void repaintSelection(Object o) {
                if ((o instanceof JList)) {
                    this.repaintListSelection((JList)o);
                }
                else if ((o instanceof JTable)) {
                    this.repaintTableSelection((JTable)o);
                }
            }
            
            private void repaintListSelection(JList list) {
                int[] selectedIndices;
                for (int n : selectedIndices = list.getSelectedIndices()) {
                    list.repaint(list.getCellBounds(n, n));
                }
            }
            
            private void repaintTableSelection(JTable table) {
                int minSelectionIndex = table.getSelectionModel().getMinSelectionIndex();
                int maxSelectionIndex = table.getSelectionModel().getMaxSelectionIndex();
                if (minSelectionIndex == -1 || maxSelectionIndex == -1) {
                    return;
                }
                int convertColumnIndexToView = table.convertColumnIndexToView(0);
                table.repaint(table.getCellRect(minSelectionIndex, convertColumnIndexToView, false).union(table.getCellRect(maxSelectionIndex, convertColumnIndexToView, false)));
                return;
            }
        };
    }
    
    class ViewTypeAction extends AbstractAction
    {
        private int viewType;
        
        ViewTypeAction(int viewType) {
            super(FilePane.this.viewTypeActionNames[viewType]);
            String newValue;
            switch (this.viewType = viewType) {
                case 0: {
                    newValue = "viewTypeList";
                    break;
                }
                case 1: {
                    newValue = "viewTypeDetails";
                    break;
                }
                default: {
                    newValue = (String)this.getValue("Name");
                    break;
                }
            }
            this.putValue("ActionCommandKey", newValue);
        }
        
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            FilePane.this.setViewType(this.viewType);
        }
    }
    
    private class SortableListModel extends AbstractListModel<Object> implements TableModelListener, RowSorterListener
    {
        public SortableListModel() {
            FilePane.access$900(FilePane.this).addTableModelListener(this);
            FilePane.access$100(FilePane.this).addRowSorterListener(this);
        }
        
        @Override
        public int getSize() {
            return FilePane.this.getModel().getSize();
        }
        
        @Override
        public Object getElementAt(int index) {
            return FilePane.this.getModel().getElementAt(FilePane.access$100(FilePane.this).convertRowIndexToModel(index));
        }
        
        @Override
        public void tableChanged(TableModelEvent tableModelEvent) {
            this.fireContentsChanged(this, 0, this.getSize());
        }
        
        @Override
        public void sorterChanged(RowSorterEvent rowSorterEvent) {
            this.fireContentsChanged(this, 0, this.getSize());
        }
    }
    
    class DetailsTableModel extends AbstractTableModel implements ListDataListener
    {
        JFileChooser chooser;
        BasicDirectoryModel directoryModel;
        ShellFolderColumnInfo[] columns;
        int[] columnMap;
        
        DetailsTableModel(JFileChooser chooser) {
            this.chooser = chooser;
            (this.directoryModel = FilePane.this.getModel()).addListDataListener(this);
            this.updateColumnInfo();
        }
        
        void updateColumnInfo() {
            File file = this.chooser.getCurrentDirectory();
            if (file != null && FilePane.usesShellFolder(this.chooser)) {
                try {
                    file = ShellFolder.getShellFolder(file);
                }
                catch (FileNotFoundException ex) {}
            }
            ShellFolderColumnInfo[] folderColumns = ShellFolder.getFolderColumns(file);
            ArrayList o = new ArrayList();
            this.columnMap = new int[folderColumns.length];
            for (int i = 0; i < folderColumns.length; ++i) {
                ShellFolderColumnInfo e = folderColumns[i];
                if (e.isVisible()) {
                    this.columnMap[o.size()] = i;
                    o.add(e);
                }
            }
            o.toArray(this.columns = new ShellFolderColumnInfo[o.size()]);
            this.columnMap = Arrays.copyOf(this.columnMap, this.columns.length);
            List<Object> list = (FilePane.this.rowSorter == null) ? null : FilePane.this.rowSorter.getSortKeys();
            this.fireTableStructureChanged();
            this.restoreSortKeys(list);
        }
        
        private void restoreSortKeys(List<? extends RowSorter.SortKey> sortKeys) {
            if (sortKeys != null) {
                int i = 0;
                while (i < sortKeys.size()) {
                    if (((RowSorter.SortKey)sortKeys.get(i)).getColumn() >= this.columns.length) {
                        sortKeys = null;
                        break;
                    }
                    ++i;
                }
                if (sortKeys != null) {
                    FilePane.this.rowSorter.setSortKeys(sortKeys);
                }
            }
        }
        
        @Override
        public int getRowCount() {
            return this.directoryModel.getSize();
        }
        
        @Override
        public int getColumnCount() {
            return this.columns.length;
        }
        
        @Override
        public Object getValueAt(int index, int n) {
            return this.getFileColumnValue((File)this.directoryModel.getElementAt(index), n);
        }
        
        private Object getFileColumnValue(File file, int n) {
            return (n == 0) ? file : ShellFolder.getFolderColumnValue(file, this.columnMap[n]);
        }
        
        @Override
        public void setValueAt(Object o, int n, int n2) {
            if (n2 == 0) {
                JFileChooser fileChooser = FilePane.this.getFileChooser();
                File file = (File)this.getValueAt(n, n2);
                if (file != null) {
                    String name = fileChooser.getName(file);
                    String name2 = file.getName();
                    String s = ((String)o).trim();
                    if (!s.equals(name)) {
                        int length = name2.length();
                        int length2 = name.length();
                        if (length > length2 && name2.charAt(length2) == '.') {
                            s += name2.substring(length2);
                        }
                        FileSystemView fileSystemView = fileChooser.getFileSystemView();
                        File fileObject = fileSystemView.createFileObject(file.getParentFile(), s);
                        if (fileObject.exists()) {
                            JOptionPane.showMessageDialog(fileChooser, MessageFormat.format(FilePane.this.renameErrorFileExistsText, new Object[] { name2 }), FilePane.this.renameErrorTitleText, 0);
                        }
                        else if (FilePane.this.getModel().renameFile(file, fileObject)) {
                            if (fileSystemView.isParent(fileChooser.getCurrentDirectory(), fileObject)) {
                                SwingUtilities.invokeLater(new Runnable() {
                                    @Override
                                    public void run() {
                                        if (fileChooser.isMultiSelectionEnabled()) {
                                            fileChooser.setSelectedFiles(new File[] { fileObject });
                                        }
                                        else {
                                            fileChooser.setSelectedFile(fileObject);
                                        }
                                    }
                                });
                            }
                        }
                        else {
                            JOptionPane.showMessageDialog(fileChooser, MessageFormat.format(FilePane.this.renameErrorText, new Object[] { name2 }), FilePane.this.renameErrorTitleText, 0);
                        }
                    }
                }
            }
        }
        
        @Override
        public boolean isCellEditable(int n, int n2) {
            File currentDirectory = FilePane.this.getFileChooser().getCurrentDirectory();
            return !FilePane.this.readOnly && n2 == 0 && FilePane.this.canWrite(currentDirectory);
        }
        
        @Override
        public void contentsChanged(ListDataEvent listDataEvent) {
            new FilePane.DelayedSelectionUpdater();
            this.fireTableDataChanged();
        }
        
        @Override
        public void intervalAdded(ListDataEvent listDataEvent) {
            int index0 = listDataEvent.getIndex0();
            if (index0 == listDataEvent.getIndex1()) {
                File file = (File)FilePane.this.getModel().getElementAt(index0);
                if (file.equals(FilePane.this.newFolderFile)) {
                    new FilePane.DelayedSelectionUpdater(file);
                    FilePane.this.newFolderFile = null;
                }
            }
            this.fireTableRowsInserted(listDataEvent.getIndex0(), listDataEvent.getIndex1());
        }
        
        @Override
        public void intervalRemoved(ListDataEvent listDataEvent) {
            this.fireTableRowsDeleted(listDataEvent.getIndex0(), listDataEvent.getIndex1());
        }
        
        public ShellFolderColumnInfo[] getColumns() {
            return this.columns;
        }
        
        static Object access$1800(FilePane.DetailsTableModel detailsTableModel, File file, int n) {
            return detailsTableModel.getFileColumnValue(file, n);
        }
    }
    
    private class DetailsTableRowSorter extends TableRowSorter<TableModel>
    {
        public DetailsTableRowSorter() {
            this.setModelWrapper(new FilePane.DetailsTableRowSorter.SorterModelWrapper());
        }
        
        public void updateComparators(ShellFolderColumnInfo[] array) {
            for (int i = 0; i < array.length; ++i) {
                Comparator<Object> comparator = array[i].getComparator();
                if (comparator != null) {
                    comparator = new FilePane.DirectoriesFirstComparatorWrapper(i, comparator);
                }
                this.setComparator(i, comparator);
            }
        }
        
        @Override
        public void sort() {
            ShellFolder.invoke(new Callable<Void>() {
                @Override
                public Void call() {
                    FilePane.DetailsTableRowSorter.access$1601(FilePane.DetailsTableRowSorter.this);
                    return null;
                }
            });
        }
        
        @Override
        public void modelStructureChanged() {
            super.modelStructureChanged();
            this.updateComparators(FilePane.this.detailsTableModel.getColumns());
        }
        
        static void access$1601(FilePane.DetailsTableRowSorter detailsTableRowSorter) {
            detailsTableRowSorter.sort();
        }
        
        private class SorterModelWrapper extends DefaultRowSorter.ModelWrapper<TableModel, Integer>
        {
            @Override
            public TableModel getModel() {
                return FilePane.access$900(FilePane.this);
            }
            
            @Override
            public int getColumnCount() {
                return FilePane.access$900(FilePane.this).getColumnCount();
            }
            
            @Override
            public int getRowCount() {
                return FilePane.access$900(FilePane.this).getRowCount();
            }
            
            @Override
            public Object getValueAt(int index, int n) {
                return FilePane.this.getModel().getElementAt(index);
            }
            
            @Override
            public Integer getIdentifier(int i) {
                return Integer.valueOf(i);
            }
        }
    }
    
    private class DirectoriesFirstComparatorWrapper implements Comparator<File>
    {
        private Comparator comparator;
        private int column;
        
        public DirectoriesFirstComparatorWrapper(int column, Comparator comparator) {
            this.column = column;
            this.comparator = comparator;
        }
        
        @Override
        public int compare(File f, File f2) {
            if (f != null && f2 != null) {
                int traversable = FilePane.this.getFileChooser().isTraversable(f);
                int traversable2 = FilePane.this.getFileChooser().isTraversable(f2);
                if (traversable && traversable2 == 0) {
                    return -1;
                }
                if (traversable == 0 && traversable2) {
                    return 1;
                }
            }
            if (FilePane.this.detailsTableModel.getColumns()[this.column].isCompareByColumn()) {
                return this.comparator.compare(FilePane.DetailsTableModel.access$1800(FilePane.access$900(FilePane.this), f, this.column), FilePane.DetailsTableModel.access$1800(FilePane.access$900(FilePane.this), f2, this.column));
            }
            return this.comparator.compare(f, f2);
        }
    }
    
    private class DetailsTableCellEditor extends DefaultCellEditor
    {
        private final JTextField tf;
        
        public DetailsTableCellEditor(JTextField textField) {
            super(textField);
            (this.tf = textField).setName("Table.editor");
            textField.addFocusListener(FilePane.this.editorFocusListener);
        }
        
        @Override
        public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
            Component tableCellEditorComponent = super.getTableCellEditorComponent(table, value, isSelected, row, column);
            if ((value instanceof File)) {
                this.tf.setText(FilePane.this.getFileChooser().getName((File)value));
                this.tf.selectAll();
                return tableCellEditorComponent;
            }
            return tableCellEditorComponent;
        }
    }
    
    class DetailsTableCellRenderer extends DefaultTableCellRenderer
    {
        JFileChooser chooser;
        DateFormat df;
        
        DetailsTableCellRenderer(JFileChooser chooser) {
            this.chooser = chooser;
            this.df = DateFormat.getDateTimeInstance(3, 3, chooser.getLocale());
        }
        
        @Override
        public void setBounds(int x, int y, int min, int height) {
            if (this.getHorizontalAlignment() == 10 && !FilePane.this.fullRowSelection) {
                min = Math.min(min, this.getPreferredSize().width + 4);
            }
            else {
                x -= 4;
            }
            super.setBounds(x, y, min, height);
        }
        
        @Override
        public Insets getInsets(Insets insets) {
            Insets insets2;
            insets = (insets2 = super.getInsets(insets));
            insets2.left += 4;
            Insets insets3 = insets;
            insets3.right += 4;
            return insets;
        }
        
        @Override
        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int viewColumnIndex) {
            if ((table.convertColumnIndexToModel(viewColumnIndex) != 0 || (FilePane.this.listViewWindowsStyle && !table.isFocusOwner())) && !FilePane.this.fullRowSelection) {
                isSelected = false;
            }
            super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, viewColumnIndex);
            this.setIcon(null);
            Integer n = FilePane.this.detailsTableModel.getColumns()[table.convertColumnIndexToModel(viewColumnIndex)].getAlignment();
            if (n == null) {
                n = Integer.valueOf((value instanceof Number) ? 4 : 10);
            }
            this.setHorizontalAlignment((int)n);
            String text;
            if (value == null) {
                text = "";
            }
            else if ((value instanceof File)) {
                File file = (File)value;
                text = this.chooser.getName(file);
                this.setIcon(this.chooser.getIcon(file));
            }
            else if ((value instanceof Long)) {
                long n2 = (long)value / 1024L;
                if (FilePane.this.listViewWindowsStyle) {
                    text = MessageFormat.format(FilePane.this.kiloByteString, new Object[] { Long.valueOf(n2 + 1L) });
                }
                else if (n2 < 1024L) {
                    text = MessageFormat.format(FilePane.this.kiloByteString, new Object[] { Long.valueOf((n2 == 0L) ? 1L : n2) });
                }
                else {
                    long l = n2 / 1024L;
                    if (l < 1024L) {
                        text = MessageFormat.format(FilePane.this.megaByteString, new Object[] { Long.valueOf(l) });
                    }
                    else {
                        text = MessageFormat.format(FilePane.this.gigaByteString, new Object[] { Long.valueOf(l / 1024L) });
                    }
                }
            }
            else if ((value instanceof Date)) {
                text = this.df.format((Date)value);
            }
            else {
                text = value.toString();
            }
            this.setText(text);
            return this;
        }
    }
    
    private class AlignableTableHeaderRenderer implements TableCellRenderer
    {
        TableCellRenderer wrappedRenderer;
        
        public AlignableTableHeaderRenderer(TableCellRenderer wrappedRenderer) {
            this.wrappedRenderer = wrappedRenderer;
        }
        
        @Override
        public Component getTableCellRendererComponent(JTable table, Object o, boolean b, boolean b2, int n, int viewColumnIndex) {
            Component tableCellRendererComponent = this.wrappedRenderer.getTableCellRendererComponent(table, o, b, b2, n, viewColumnIndex);
            Integer n2 = FilePane.this.detailsTableModel.getColumns()[table.convertColumnIndexToModel(viewColumnIndex)].getAlignment();
            if (n2 == null) {
                n2 = Integer.valueOf(0);
            }
            if ((tableCellRendererComponent instanceof JLabel)) {
                ((JLabel)tableCellRendererComponent).setHorizontalAlignment((int)n2);
                return tableCellRendererComponent;
            }
            return tableCellRendererComponent;
        }
    }
    
    private class DelayedSelectionUpdater implements Runnable
    {
        File editFile;
        
        DelayedSelectionUpdater(FilePane filePane) {
            this(filePane, null);
        }
        
        DelayedSelectionUpdater(File editFile) {
            this.editFile = editFile;
            if (FilePane.this.isShowing()) {
                SwingUtilities.invokeLater(this);
            }
        }
        
        @Override
        public void run() {
            FilePane.this.setFileSelected();
            if (this.editFile != null) {
                FilePane.access$600(FilePane.this, FilePane.access$100(FilePane.this).convertRowIndexToView(FilePane.this.getModel().indexOf(this.editFile)));
                this.editFile = null;
            }
        }
    }
    
    class EditActionListener implements ActionListener
    {
        @Override
        public void actionPerformed(ActionEvent actionEvent) {
            FilePane.access$200(FilePane.this);
        }
    }
    
    protected class FileRenderer extends DefaultListCellRenderer
    {
        @Override
        public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
            if (FilePane.this.listViewWindowsStyle && !list.isFocusOwner()) {
                isSelected = false;
            }
            super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
            File f = (File)value;
            String name = FilePane.this.getFileChooser().getName(f);
            this.setText(name);
            this.setFont(list.getFont());
            Icon icon = FilePane.this.getFileChooser().getIcon(f);
            if (icon != null) {
                this.setIcon(icon);
            }
            else if ((boolean)FilePane.this.getFileChooser().getFileSystemView().isTraversable(f)) {
                this.setText(name + File.separator);
            }
            return this;
        }
    }
    
    private class Handler implements MouseListener
    {
        private MouseListener doubleClickListener;
        
        @Override
        public void mouseClicked(MouseEvent anEvent) {
            JComponent component = (JComponent)anEvent.getSource();
            int n;
            if ((component instanceof JList)) {
                n = SwingUtilities2.loc2IndexFileList(FilePane.this.list, anEvent.getPoint());
            }
            else if ((component instanceof JTable)) {
                JTable table = (JTable)component;
                Point point = anEvent.getPoint();
                n = table.rowAtPoint(point);
                if (SwingUtilities2.pointOutsidePrefSize(table, n, table.columnAtPoint(point), point) && !FilePane.this.fullRowSelection) {
                    return;
                }
                if (n >= 0 && FilePane.this.list != null && FilePane.this.listSelectionModel.isSelectedIndex(n)) {
                    Rectangle cellBounds = FilePane.this.list.getCellBounds(n, n);
                    MouseEvent mouseEvent = new MouseEvent(FilePane.this.list, anEvent.getID(), anEvent.getWhen(), anEvent.getModifiers(), cellBounds.x + 1, cellBounds.y + cellBounds.height / 2, anEvent.getXOnScreen(), anEvent.getYOnScreen(), anEvent.getClickCount(), anEvent.isPopupTrigger(), anEvent.getButton());
                    AWTAccessor.MouseEventAccessor mouseEventAccessor = AWTAccessor.getMouseEventAccessor();
                    mouseEventAccessor.setCausedByTouchEvent(mouseEvent, mouseEventAccessor.isCausedByTouchEvent(anEvent));
                    anEvent = mouseEvent;
                }
            }
            else {
                return;
            }
            if (n >= 0 && SwingUtilities.isLeftMouseButton(anEvent)) {
                JFileChooser fileChooser = FilePane.this.getFileChooser();
                if (anEvent.getClickCount() == 1 && component instanceof JList) {
                    if ((!fileChooser.isMultiSelectionEnabled() || fileChooser.getSelectedFiles().length <= 1) && n >= 0 && FilePane.this.listSelectionModel.isSelectedIndex(n) && FilePane.access$3100(FilePane.this) == n && FilePane.this.editFile == null) {
                        FilePane.access$600(FilePane.this, n);
                    }
                    else if (n >= 0) {
                        FilePane.access$3200(FilePane.this, n);
                    }
                    else {
                        FilePane.access$3300(FilePane.this);
                    }
                }
                else if (anEvent.getClickCount() == 2) {
                    FilePane.access$3300(FilePane.this);
                }
            }
            if (this.getDoubleClickListener() != null) {
                this.getDoubleClickListener().mouseClicked(anEvent);
            }
        }
        
        @Override
        public void mouseEntered(MouseEvent mouseEvent) {
            JComponent component = (JComponent)mouseEvent.getSource();
            if ((component instanceof JTable)) {
                JTable table = (JTable)mouseEvent.getSource();
                TransferHandler transferHandler = FilePane.this.getFileChooser().getTransferHandler();
                if (transferHandler != table.getTransferHandler()) {
                    table.setTransferHandler(transferHandler);
                }
                int dragEnabled = FilePane.this.getFileChooser().getDragEnabled();
                if (dragEnabled != (table.getDragEnabled() ? 1 : 0)) {
                    table.setDragEnabled((boolean)dragEnabled);
                }
            }
            else if (component instanceof JList && this.getDoubleClickListener() != null) {
                this.getDoubleClickListener().mouseEntered(mouseEvent);
            }
        }
        
        @Override
        public void mouseExited(MouseEvent mouseEvent) {
            if (mouseEvent.getSource() instanceof JList && this.getDoubleClickListener() != null) {
                this.getDoubleClickListener().mouseExited(mouseEvent);
            }
        }
        
        @Override
        public void mousePressed(MouseEvent mouseEvent) {
            if (mouseEvent.getSource() instanceof JList && this.getDoubleClickListener() != null) {
                this.getDoubleClickListener().mousePressed(mouseEvent);
            }
        }
        
        @Override
        public void mouseReleased(MouseEvent mouseEvent) {
            if (mouseEvent.getSource() instanceof JList && this.getDoubleClickListener() != null) {
                this.getDoubleClickListener().mouseReleased(mouseEvent);
            }
        }
        
        private MouseListener getDoubleClickListener() {
            if (this.doubleClickListener == null && FilePane.this.list != null) {
                this.doubleClickListener = FilePane.this.fileChooserUIAccessor.createDoubleClickListener(FilePane.this.list);
            }
            return this.doubleClickListener;
        }
    }
    
    public interface FileChooserUIAccessor
    {
        public abstract JFileChooser getFileChooser();
        
        public abstract BasicDirectoryModel getModel();
        
        public abstract JPanel createList();
        
        public abstract JPanel createDetailsView();
        
        public abstract boolean isDirectorySelected();
        
        public abstract File getDirectory();
        
        public abstract Action getApproveSelectionAction();
        
        public abstract Action getChangeToParentDirectoryAction();
        
        public abstract Action getNewFolderAction();
        
        public abstract MouseListener createDoubleClickListener(JList p0);
        
        public abstract ListSelectionListener createListSelectionListener();
    }
}
